

/*
 * I. ARIT 1993 Hidirbeyli,Germencik,AYDIN,TURKIYE.  09400
 *
 *
 * Copyright (C) 1993 Ismail ARIT
 *
 * This file  is distributed in the hope that it will be useful, but without any
 * warranty.  No author or distributor accepts responsibility to anyone for
 * the consequences of using it or for whether it serves any particular
 * purpose or works at all.
 *
 *
 * Everyone is granted permission to copy, modify and redistribute this file
 * under the following conditions:
 *
 *
 * Everyone is granted permission to copy, modify and redistribute this file
 * under the following conditions:
 *
 *
 * Permission is granted to anyone to make or distribute copies of the source
 * code, either as received or modified, in any medium, provided that all
 * copyright notices, permission and nonwarranty notices are preserved, and
 * that the distributor grants the recipient permission for further
 * redistribution as permitted by this document.
 *
 */






#include "xquran.h"

#include <X11/Xaw/Command.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/List.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Viewport.h>


/* externs */

extern int
                readSureNames(Widget w, char *path);
extern void
                loadAyet(Widget w, char *filename);
extern          String
*               sures[NUMBEROFSURE];



/* some globals */

XtAppContext    app;
Widget          top;
Widget          box, box2;
Widget          quit, lookFor, search, 
                viewport,sureList, ayetList, lookForInCur;




/* obvious */
void
Quit(w, client_data, call_data)
	Widget          w;
	XtPointer       client_data, call_data;
{
	dprintf("exitting..\n");
	exit(0);
}

/* get selected item from the sura list and display it in ayet list */
void
SelectedItem(w, client_data, call_data)
	Widget          w;
	XtPointer       client_data, call_data;
{
	char            buf[256];

	/*
	 * client_data is supposed to be the current selection, but it didn't
	 * work for me, so we'll use this function call to get the current
	 * selection
	 */
	XawListReturnStruct *selected = XawListShowCurrent(w);

	/*
	 * for some starange reason, X11R5 widget doesn't update if I don't
	 * do this
	 */
	loadAyet(ayetList, "/dev/null");


	sprintf(buf, "%s/%s", PATH_TO_QURAN, selected->string);
	loadAyet(ayetList, buf);
	dprintf("%s\n", buf);
}






/* to get the search string */
String
stringAt(w)
	Widget          w;
{
	String          string;
	Arg             args[1];

	XtSetArg(args[0], XtNstring, &string);
	XtGetValues(w, args, 1);
	return (string);

}



/* search the Quran */

void
searchQuran(w, client_data, call_data)
	Widget          w;
	XtPointer       client_data, call_data;
{
	char            buf[256];
	String          str;

	str = stringAt(search);

	if (strcmp((char *) str, "") != 0) {
		sprintf(buf, "%s -n %s %s/*.* | %s -F/ '{print $NF}' > /tmp/.foundlist",
			GREP, str, PATH_TO_QURAN, AWK);

		system(buf);
		/*
		 * this is not an ayet, but we'll just use it to load
		 * foundlist
		 */
		loadAyet(ayetList, "/tmp/.foundlist");
		/* remove the file */
		if (remove("/tmp/.foundlist") == -1)
			perror("can't remove /tmp/.foundlist file "), exit(0);


		dprintf(" %s \n", str);


	}
}










main(argc, argv)
	int             argc;
	char          **argv;
{
	Arg             args[5];
	Cardinal        numargs = 0;
	int             i, j;
	char            buf[256];


	top = XtVaAppInitialize(
				&app,
				"XQuran",
				NULL, 0,
				&argc, argv,
				NULL,
				NULL);

	box = XtVaCreateManagedWidget(
				      "box",	/* widget name */
				      panedWidgetClass,	/* widget class */
				      top,	/* parent widget */
				      NULL);	/* terminate varargs list */

	box2 = XtVaCreateManagedWidget(
				       "box2",	/* widget name */
				       boxWidgetClass,	/* widget class */
				       box,	/* parent widget */
				       XtNorientation, XtEhorizontal,
				       NULL);	/* terminate varargs list */


	quit = XtVaCreateManagedWidget(
				       "Quit",	/* widget name */
				       commandWidgetClass,	/* widget class */
				       box2,	/* parent widget */
				       NULL);	/* terminate varargs list */


	lookFor = XtVaCreateManagedWidget(
					  "search in Quran->>",	/* widget name */
					  commandWidgetClass,	/* widget class */
					  box2,	/* parent widget */
					  NULL);	/* terminate varargs
							 * list */


	search = XtVaCreateManagedWidget(
					 "         ",	/* widget name */
					 asciiTextWidgetClass,	/* widget class */
					 box2,	/* parent widget */
					 XtNeditType, XawtextEdit,
					 XtNwidth, 150,
					 XtNstring, NULL,	/* init to null */
					 NULL);	/* terminate varargs list */

	lookForInCur = XtVaCreateManagedWidget(
				       "Ctrl-S/R to search in current sura",	/* widget name */
					       labelWidgetClass,	/* widget class */
					       box2,	/* parent widget */
					       NULL);	/* terminate varargs
							 * list */

        viewport = XtVaCreateManagedWidget(
                                           " ", /* widget name */
                                           viewportWidgetClass,     
                                           box, /* parent widget */
                                           XtNallowVert, True,
                                           NULL);       /* terminate varargs*/




	sureList = XtVaCreateManagedWidget(
					   " ",	/* widget name */
					   listWidgetClass, /* widget class */
					   viewport,	/* parent widget */
					   XtNverticalList, True,
					   XtNstring, NULL, /* init to null */
					   NULL);	/* terminate varargs
							 * list */

	/* read sures */
	i = readSureNames(sureList, PATH_TO_QURAN);

	for (j = 0; j < i; j++)
		dprintf("%s \n", sures[j]);

	/* use the first sura as a first one to show */
	sprintf(buf, "%s/%s", PATH_TO_QURAN, (char *) sures[0]);
	ayetList = XtVaCreateManagedWidget(
					   " ",	/* widget name */
					   asciiTextWidgetClass,	/* widget class */
					   box,	/* parent widget */
					   XtNtype, XawAsciiFile,
					   XtNscrollVertical, True,
					   XtNstring, buf,/*to first sura */
					   NULL);	/* terminate varargs
							 * list */




	XtAddCallback(quit, XtNcallback, Quit, 0);
	XtAddCallback(sureList, XtNcallback, SelectedItem, 0);
	XtAddCallback(lookFor, XtNcallback, searchQuran, 0);



	XtRealizeWidget(top);

	XtAppMainLoop(app);



}				/* end of main */




